com.beaglebuddy.id3.enums.v24

## Enum FrameType

- java.lang.Object
- - java.lang.Enum<FrameType>
  - - com.beaglebuddy.id3.enums.v24.FrameType

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Comparable<FrameType>

      public enum FrameType
      extends java.lang.Enum<FrameType>

  The ID3v2.4 Tag Specification defines 83 types of frames.

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant and Description
    `ALBUM_SORT_ORDER` frame id - TSOA, album sort order
    `ALBUM_TITLE` frame id - TALB, album/movie/show title
    `ATTACHED_PICTURE` frame id - APIC, attached picture
    `AUDIO_ENCRYPTION` frame id - AENC, audio encryption
    `AUDIO_SEEK_POINT_INDEX` frame id - ASPI, audio seek point index
    `BAND` frame id - TPE2, band/orchestra/accompaniment
    `BEATS_PER_MINUTE` frame id - TBPM, bpm (beats per minute)
    `COMMENTS` frame id - COMM, comments
    `COMMERCIAL` frame id - COMR, commercial
    `COMMERCIAL_INFORMATION` frame id - WCOM, commercial information
    `COMPOSER` frame id - TCOM, composer
    `CONDUCTOR` frame id - TPE3, conductor/performer refinement
    `CONTENT_GROUP_DESCRIPTION` frame id - TIT1, content group description
    `CONTENT_TYPE` frame id - TCON, content type
    `COPYRIGHT_LEGAL_INFORMATION` frame id - WCOP, copyright/legal information
    `COPYRIGHT_MESSAGE` frame id - TCOP, copyright message
    `ENCODED_BY` frame id - TENC, encoded by
    `ENCODING_TIME` frame id - TDEN, encoding date/time
    `ENCRYPTION_METHOD_REGISTRATION` frame id - ENCR, encryption method registration
    `EQUALIZATION` frame id - EQU2, equalization (2)
    `EVENT_TIMING_CODES` frame id - ETCO, event timing codes
    `FILE_OWNER` frame id - TOWN, file owner/licensee
    `FILE_TYPE` frame id - TFLT, file type
    `GENERAL_ENCAPSULATED_OBJECT` frame id - GEOB, general encapsulated object
    `GROUP_IDENTIFICATION_REGISTRATION` frame id - GRID, group identification registration
    `INITIAL_KEY` frame id - TKEY, initial key
    `INTERNATIONAL_STANDARD_RECORDING_CODE` frame id - TSRC, isrc (international standard recording code)
    `INTERNET_RADIO_STATION_NAME` frame id - TRSN, internet radio station name
    `INTERNET_RADIO_STATION_OWNER` frame id - TRSO, internet radio station owner
    `INTERPRETED_MODIFIED_BY` frame id - TPE4, interpreted, remixed, or otherwise modified by
    `INVOLVED_PEOPLE_LIST` frame id - TIPL, involved people list
    `LANGUAGE` frame id - TLAN, language(s) the song is sung in
    `LEAD_PERFORMER` frame id - TPE1, lead performer(s)/soloist(s)
    `LENGTH` frame id - TLEN, length of the song (in ms)
    `LINKED_INFORMATION` frame id - IPLS, involved people list
    `LYRICIST` frame id - TEXT, lyricist/text writer
    `MEDIA_TYPE` frame id - TMED, media type
    `MOOD` frame id - TMOO, mood
    `MPEG_LOCATION_LOOKUP_TABLE` frame id - MLLT, mpeg location lookup table
    `MUSIC_CD_IDENTIFIER` frame id - MCDI, music cd identifier
    `MUSICIANS_CREDIT_LIST` frame id - TMCL, musician credits list
    `OFFICIAL_ARTIST_WEBPAGE` frame id - WOAR, official artist/performer webpage
    `OFFICIAL_AUDIO_FILE_WEBPAGE` frame id - WOAF, official audio file webpage
    `OFFICIAL_AUDIO_SOURCE_WEBPAGE` frame id - WOAS, official audio source webpage
    `OFFICIAL_INTERNET_RADIO_STATION_HOMEPAGE` frame id - WORS, official internet radio station homepage
    `ORIGINAL_ALBUM_TITLE` frame id - TOAL, original album/movie/show title
    `ORIGINAL_ARTIST` frame id - TOPE, original artist(s)/performer(s)
    `ORIGINAL_FILENAME` frame id - TOFN, original filename
    `ORIGINAL_LYRICIST` frame id - TOLY, original lyricist(s)/text writer(s)
    `ORIGINAL_RELEASE_TIME` frame id - TDOR, original release date/time
    `OWNERSHIP` frame id - OWNE, ownership
    `PART_OF_A_SET` frame id - TPOS, part of a set
    `PAYMENT` frame id - WPAY, payment
    `PERFORMER_SORT_ORDER` frame id - TSOP, performer sort order
    `PLAY_COUNTER` frame id - PCNT, play counter
    `PLAYLIST_DELAY` frame id - TDLY, number of ms of silence between every song in a play list
    `POPULARIMETER` frame id - POPM, popularimeter
    `POSITION_SYNCHRONIZATION` frame id - POSS, position synchronization
    `PRIVATE` frame id - PRIV, private
    `PRODUCED_NOTICE` frame id - TPRO, produced notice
    `PUBLISHER` frame id - TPUB, publisher
    `PUBLISHERS_OFFICIAL_WEBPAGE` frame id - WPUB, publishers official webpage
    `RECOMMENDED_BUFFER_SIZE` frame id - RBUF, recommended buffer size
    `RECORDING_TIME` frame id - TDRC, date and time the song was recorded
    `RELATIVE_VOLUME_ADJUSTMENT` frame id - RVA2, relative volume adjustment (2)
    `RELEASE_TIME` frame id - TDRL, date and time the song was released
    `REVERB` frame id - RVRB, reverb settings
    `SEEK_FRAME` frame id - SEEK, seek frame
    `SET_SUBTITLE` frame id - TSST, set subtitle
    `SIGNATURE` frame id - SIGN, signature frame
    `SOFTWARE_HARDWARE_ENCODING_SETTINGS` frame id - TSSE, software/hardware and settings used for encoding
    `SONG_TITLE` frame id - TIT2, title/songname/content description
    `SUBTITLE_REFINEMENT` frame id - TIT3, subtitle/description refinement
    `SYNCHRONIZED_LYRIC_TEXT` frame id - SYLT, synchronized lyric/text
    `SYNCHRONIZED_TEMPO_CODES` frame id - SYTC, synchronized tempo codes
    `TAGGING_TIME` frame id - TDTG, date and time the song was tagged
    `TERMS_OF_USE` frame id - USER, terms of use
    `TITLE_SORT_ORDER` frame id - TSOT, title sort order
    `TRACK_NUMBER` frame id - TRCK, track number/position in set
    `UNIQUE_FILE_IDENTIFIER` frame id - UFID, unique file identifier
    `UNSYCHRONIZED_LYRICS` frame id - USLT, unsychronized lyrics/text transcription
    `USER_DEFINED_TEXT_INFORMATION` frame id - TXXX, user defined text information frame
    `USER_DEFINED_URL_LINK_FRAME` frame id - WXXX, user defined url link

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `FRAME_ID_LENGTH` length of ID3v2.4 frame ids

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getDescription()` gets the description of the frame type.
    `java.lang.Class<?>` | `getFrameBodyClass()` gets the class used to implement the frame's body.
    `java.lang.reflect.Constructor<?>` | `getFrameBodyConstructor()` gets the constructor for the frame body's class used to parse the frame's body from an .mp3 file.
    `static FrameType` | `getFrameType(java.lang.String frameId)` convert a string value to its corresponding frame type enum.
    `java.lang.String` | `getId()` gets the ID3v2.4 frame id.
    `java.lang.String` | `getName()` gets the name of the frame type.
    `java.lang.String` | `toString()` gets a string representation of the frame type enum.
    `static FrameType` | `valueOf(java.lang.String name)` Returns the enum constant of this type with the specified name.
    `static FrameType[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### AUDIO_ENCRYPTION

          public static final FrameType AUDIO_ENCRYPTION

      frame id - AENC, audio encryption

    - #### ATTACHED_PICTURE

          public static final FrameType ATTACHED_PICTURE

      frame id - APIC, attached picture

    - #### AUDIO_SEEK_POINT_INDEX

          public static final FrameType AUDIO_SEEK_POINT_INDEX

      frame id - ASPI, audio seek point index

    - #### COMMENTS

          public static final FrameType COMMENTS

      frame id - COMM, comments

    - #### COMMERCIAL

          public static final FrameType COMMERCIAL

      frame id - COMR, commercial

    - #### ENCRYPTION_METHOD_REGISTRATION

          public static final FrameType ENCRYPTION_METHOD_REGISTRATION

      frame id - ENCR, encryption method registration

    - #### EQUALIZATION

          public static final FrameType EQUALIZATION

      frame id - EQU2, equalization (2)

    - #### EVENT_TIMING_CODES

          public static final FrameType EVENT_TIMING_CODES

      frame id - ETCO, event timing codes

    - #### GENERAL_ENCAPSULATED_OBJECT

          public static final FrameType GENERAL_ENCAPSULATED_OBJECT

      frame id - GEOB, general encapsulated object

    - #### GROUP_IDENTIFICATION_REGISTRATION

          public static final FrameType GROUP_IDENTIFICATION_REGISTRATION

      frame id - GRID, group identification registration

    - #### LINKED_INFORMATION

          public static final FrameType LINKED_INFORMATION

      frame id - IPLS, involved people list

    - #### MUSIC_CD_IDENTIFIER

          public static final FrameType MUSIC_CD_IDENTIFIER

      frame id - MCDI, music cd identifier

    - #### MPEG_LOCATION_LOOKUP_TABLE

          public static final FrameType MPEG_LOCATION_LOOKUP_TABLE

      frame id - MLLT, mpeg location lookup table

    - #### OWNERSHIP

          public static final FrameType OWNERSHIP

      frame id - OWNE, ownership

    - #### PLAY_COUNTER

          public static final FrameType PLAY_COUNTER

      frame id - PCNT, play counter

    - #### POPULARIMETER

          public static final FrameType POPULARIMETER

      frame id - POPM, popularimeter

    - #### POSITION_SYNCHRONIZATION

          public static final FrameType POSITION_SYNCHRONIZATION

      frame id - POSS, position synchronization

    - #### PRIVATE

          public static final FrameType PRIVATE

      frame id - PRIV, private

    - #### RECOMMENDED_BUFFER_SIZE

          public static final FrameType RECOMMENDED_BUFFER_SIZE

      frame id - RBUF, recommended buffer size

    - #### RELATIVE_VOLUME_ADJUSTMENT

          public static final FrameType RELATIVE_VOLUME_ADJUSTMENT

      frame id - RVA2, relative volume adjustment (2)

    - #### REVERB

          public static final FrameType REVERB

      frame id - RVRB, reverb settings

    - #### SEEK_FRAME

          public static final FrameType SEEK_FRAME

      frame id - SEEK, seek frame

    - #### SIGNATURE

          public static final FrameType SIGNATURE

      frame id - SIGN, signature frame

    - #### SYNCHRONIZED_LYRIC_TEXT

          public static final FrameType SYNCHRONIZED_LYRIC_TEXT

      frame id - SYLT, synchronized lyric/text

    - #### SYNCHRONIZED_TEMPO_CODES

          public static final FrameType SYNCHRONIZED_TEMPO_CODES

      frame id - SYTC, synchronized tempo codes

    - #### ALBUM_TITLE

          public static final FrameType ALBUM_TITLE

      frame id - TALB, album/movie/show title

    - #### BEATS_PER_MINUTE

          public static final FrameType BEATS_PER_MINUTE

      frame id - TBPM, bpm (beats per minute)

    - #### COMPOSER

          public static final FrameType COMPOSER

      frame id - TCOM, composer

    - #### CONTENT_TYPE

          public static final FrameType CONTENT_TYPE

      frame id - TCON, content type

    - #### COPYRIGHT_MESSAGE

          public static final FrameType COPYRIGHT_MESSAGE

      frame id - TCOP, copyright message

    - #### ENCODING_TIME

          public static final FrameType ENCODING_TIME

      frame id - TDEN, encoding date/time

    - #### PLAYLIST_DELAY

          public static final FrameType PLAYLIST_DELAY

      frame id - TDLY, number of ms of silence between every song in a play list

    - #### ORIGINAL_RELEASE_TIME

          public static final FrameType ORIGINAL_RELEASE_TIME

      frame id - TDOR, original release date/time

    - #### RECORDING_TIME

          public static final FrameType RECORDING_TIME

      frame id - TDRC, date and time the song was recorded

    - #### RELEASE_TIME

          public static final FrameType RELEASE_TIME

      frame id - TDRL, date and time the song was released

    - #### TAGGING_TIME

          public static final FrameType TAGGING_TIME

      frame id - TDTG, date and time the song was tagged

    - #### ENCODED_BY

          public static final FrameType ENCODED_BY

      frame id - TENC, encoded by

    - #### LYRICIST

          public static final FrameType LYRICIST

      frame id - TEXT, lyricist/text writer

    - #### FILE_TYPE

          public static final FrameType FILE_TYPE

      frame id - TFLT, file type

    - #### INVOLVED_PEOPLE_LIST

          public static final FrameType INVOLVED_PEOPLE_LIST

      frame id - TIPL, involved people list

    - #### CONTENT_GROUP_DESCRIPTION

          public static final FrameType CONTENT_GROUP_DESCRIPTION

      frame id - TIT1, content group description

    - #### SONG_TITLE

          public static final FrameType SONG_TITLE

      frame id - TIT2, title/songname/content description

    - #### SUBTITLE_REFINEMENT

          public static final FrameType SUBTITLE_REFINEMENT

      frame id - TIT3, subtitle/description refinement

    - #### INITIAL_KEY

          public static final FrameType INITIAL_KEY

      frame id - TKEY, initial key

    - #### LANGUAGE

          public static final FrameType LANGUAGE

      frame id - TLAN, language(s) the song is sung in

    - #### LENGTH

          public static final FrameType LENGTH

      frame id - TLEN, length of the song (in ms)

    - #### MUSICIANS_CREDIT_LIST

          public static final FrameType MUSICIANS_CREDIT_LIST

      frame id - TMCL, musician credits list

    - #### MEDIA_TYPE

          public static final FrameType MEDIA_TYPE

      frame id - TMED, media type

    - #### MOOD

          public static final FrameType MOOD

      frame id - TMOO, mood

    - #### ORIGINAL_ALBUM_TITLE

          public static final FrameType ORIGINAL_ALBUM_TITLE

      frame id - TOAL, original album/movie/show title

    - #### ORIGINAL_FILENAME

          public static final FrameType ORIGINAL_FILENAME

      frame id - TOFN, original filename

    - #### ORIGINAL_LYRICIST

          public static final FrameType ORIGINAL_LYRICIST

      frame id - TOLY, original lyricist(s)/text writer(s)

    - #### ORIGINAL_ARTIST

          public static final FrameType ORIGINAL_ARTIST

      frame id - TOPE, original artist(s)/performer(s)

    - #### FILE_OWNER

          public static final FrameType FILE_OWNER

      frame id - TOWN, file owner/licensee

    - #### LEAD_PERFORMER

          public static final FrameType LEAD_PERFORMER

      frame id - TPE1, lead performer(s)/soloist(s)

    - #### BAND

          public static final FrameType BAND

      frame id - TPE2, band/orchestra/accompaniment

    - #### CONDUCTOR

          public static final FrameType CONDUCTOR

      frame id - TPE3, conductor/performer refinement

    - #### INTERPRETED_MODIFIED_BY

          public static final FrameType INTERPRETED_MODIFIED_BY

      frame id - TPE4, interpreted, remixed, or otherwise modified by

    - #### PART_OF_A_SET

          public static final FrameType PART_OF_A_SET

      frame id - TPOS, part of a set

    - #### PRODUCED_NOTICE

          public static final FrameType PRODUCED_NOTICE

      frame id - TPRO, produced notice

    - #### PUBLISHER

          public static final FrameType PUBLISHER

      frame id - TPUB, publisher

    - #### TRACK_NUMBER

          public static final FrameType TRACK_NUMBER

      frame id - TRCK, track number/position in set

    - #### INTERNET_RADIO_STATION_NAME

          public static final FrameType INTERNET_RADIO_STATION_NAME

      frame id - TRSN, internet radio station name

    - #### INTERNET_RADIO_STATION_OWNER

          public static final FrameType INTERNET_RADIO_STATION_OWNER

      frame id - TRSO, internet radio station owner

    - #### ALBUM_SORT_ORDER

          public static final FrameType ALBUM_SORT_ORDER

      frame id - TSOA, album sort order

    - #### PERFORMER_SORT_ORDER

          public static final FrameType PERFORMER_SORT_ORDER

      frame id - TSOP, performer sort order

    - #### TITLE_SORT_ORDER

          public static final FrameType TITLE_SORT_ORDER

      frame id - TSOT, title sort order

    - #### INTERNATIONAL_STANDARD_RECORDING_CODE

          public static final FrameType INTERNATIONAL_STANDARD_RECORDING_CODE

      frame id - TSRC, isrc (international standard recording code)

    - #### SOFTWARE_HARDWARE_ENCODING_SETTINGS

          public static final FrameType SOFTWARE_HARDWARE_ENCODING_SETTINGS

      frame id - TSSE, software/hardware and settings used for encoding

    - #### SET_SUBTITLE

          public static final FrameType SET_SUBTITLE

      frame id - TSST, set subtitle

    - #### USER_DEFINED_TEXT_INFORMATION

          public static final FrameType USER_DEFINED_TEXT_INFORMATION

      frame id - TXXX, user defined text information frame

    - #### UNIQUE_FILE_IDENTIFIER

          public static final FrameType UNIQUE_FILE_IDENTIFIER

      frame id - UFID, unique file identifier

    - #### TERMS_OF_USE

          public static final FrameType TERMS_OF_USE

      frame id - USER, terms of use

    - #### UNSYCHRONIZED_LYRICS

          public static final FrameType UNSYCHRONIZED_LYRICS

      frame id - USLT, unsychronized lyrics/text transcription

    - #### COMMERCIAL_INFORMATION

          public static final FrameType COMMERCIAL_INFORMATION

      frame id - WCOM, commercial information

    - #### COPYRIGHT_LEGAL_INFORMATION

          public static final FrameType COPYRIGHT_LEGAL_INFORMATION

      frame id - WCOP, copyright/legal information

    - #### OFFICIAL_AUDIO_FILE_WEBPAGE

          public static final FrameType OFFICIAL_AUDIO_FILE_WEBPAGE

      frame id - WOAF, official audio file webpage

    - #### OFFICIAL_ARTIST_WEBPAGE

          public static final FrameType OFFICIAL_ARTIST_WEBPAGE

      frame id - WOAR, official artist/performer webpage

    - #### OFFICIAL_AUDIO_SOURCE_WEBPAGE

          public static final FrameType OFFICIAL_AUDIO_SOURCE_WEBPAGE

      frame id - WOAS, official audio source webpage

    - #### OFFICIAL_INTERNET_RADIO_STATION_HOMEPAGE

          public static final FrameType OFFICIAL_INTERNET_RADIO_STATION_HOMEPAGE

      frame id - WORS, official internet radio station homepage

    - #### PAYMENT

          public static final FrameType PAYMENT

      frame id - WPAY, payment

    - #### PUBLISHERS_OFFICIAL_WEBPAGE

          public static final FrameType PUBLISHERS_OFFICIAL_WEBPAGE

      frame id - WPUB, publishers official webpage

    - #### USER_DEFINED_URL_LINK_FRAME

          public static final FrameType USER_DEFINED_URL_LINK_FRAME

      frame id - WXXX, user defined url link

  - ### Field Detail

    - #### FRAME_ID_LENGTH

          public static final int FRAME_ID_LENGTH

      length of ID3v2.4 frame ids
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### values

          public static FrameType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (FrameType c : FrameType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static FrameType valueOf(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null

    - #### getName

          public java.lang.String getName()

      gets the name of the frame type.
      Returns:
        the name of the frame type.

    - #### getId

          public java.lang.String getId()

      gets the ID3v2.4 frame id.
      Returns:
        the ID3v2.4 frame id.

    - #### getDescription

          public java.lang.String getDescription()

      gets the description of the frame type.
      Returns:
        the description of the frame type.

    - #### getFrameBodyClass

          public java.lang.Class<?> getFrameBodyClass()

      gets the class used to implement the frame's body.
      Returns:
        the class used to implement the frame's body.

    - #### getFrameBodyConstructor

          public java.lang.reflect.Constructor<?> getFrameBodyConstructor()

      gets the constructor for the frame body's class used to parse the frame's body from an .mp3 file.
      Returns:
        the frame body class's constructor used to parse an existing frame body from an .mp3 file.

    - #### getFrameType

          public static FrameType getFrameType(java.lang.String frameId)
                                        throws java.lang.IllegalArgumentException

      convert a string value to its corresponding frame type enum.
      Parameters:
        `frameId` - string value to be converted to a FrameType enum.
      Returns:
        the FrameType enum corresponding to the string value.
      Throws:
        `java.lang.IllegalArgumentException` - if the integral value does not correspond to a valid FrameType.

    - #### toString

          public java.lang.String toString()

      gets a string representation of the frame type enum.
      Overrides:
        `toString` in class `java.lang.Enum<FrameType>`
      Returns:
        a string representation of the frame type enum.